## About

This allows verovio to be built as a native library for Android. It does not include any Java bindings.

### Build with ndk-build

DISCLAIMER: It has been reported on various occasions that this is not working properly. There seem to be other way to have it working, and contributions would be welcome.

```sh
export ANDROID_NDK_ROOT="/opt/Android/android-ndk-r21b" # adjust to NDK install ANDROID_NDK
ndk_build=$ANDROID_NDK_ROOT/ndk-build
cd jni
$ndk_build
```

### Build with CMake

Set `NDK` and the appropriate `ABI` (e.g., to `armeabi-v7a`) environment variables and run:
```
 cmake -DCMAKE_TOOLCHAIN_FILE=$NDK/build/cmake/android.toolchain.cmake -DANDROID_ABI=$ABI -DBUILD_AS_ANDROID_LIBRARY=ON ../../cmake
 ```

### Build with Android Studio

1. Create a new project with C++ Native
2. Checkout the Verovio repository in the `./app/src/main/cpp` directory
3. Add the following to the `CMakeLists.txt` generated by Android Studio:
```
# Build Verovio as a library
set(BUILD_AS_LIBRARY ON)
# Add the subdirectory with the Verovio CMakeLists.txt
add_subdirectory(./verovio/cmake)
# Add the inlude paths with the Verovio files
file(GLOB VRV_INCLUDES "./verovio/include/*" "./verovio/libmei/*")
include_directories(${VRV_INCLUDES})
# Link the Verovio library
target_link_libraries(myapplication verovio)
```

A minimal example would look like:
```cpp
#include <jni.h>
#include <string>

#include "toolkit.h"

extern "C" JNIEXPORT jstring JNICALL
Java_com_example_myapplication_MainActivity_stringFromJNI(JNIEnv* env, jobject /* this */) {
    vrv::Toolkit tk(false);
    std::string hello = "Hello from Verovio " + tk.GetVersion();
    return env->NewStringUTF(hello.c_str());
}
```